#include "visConnPrep.H"

void testSlot ( char *cmd )
{

  printf ( "sim >>>>  inside simulation pushButton code callback slot1.... \n");
}

void testSlot2 ( char *cmd )
{

  printf ( "sim >>>>  inside simulation code callback slot2 .... \n");
}

void apply ( char *cmd )
{

  printf ( "sim >>>>  inside simulation apply code callback  .... \n");
}

void valueChanged ( char *cmd )
{

  printf ( "sim >>>>  inside simulation valueChanged code callback .... \n");
}

void currentChanged ( char *cmd )
{

  printf ( "sim >>>>  inside simulation currentChanged code callback .... \n");
}

static int visit_broadcast_int_callback(int *value, int sender)
{
    return MPI_Bcast(value, 1, MPI_INT, sender, MPI_COMM_WORLD) ;
}

static int visit_broadcast_string_callback(char *str, int len, int sender)
{
    return MPI_Bcast(str, len, MPI_CHAR, sender, MPI_COMM_WORLD) ;
}

void SetupEnvironment(){
    VisItSetBroadcastIntFunction(visit_broadcast_int_callback);
    VisItSetBroadcastStringFunction(visit_broadcast_string_callback);
    VisItSetParallel(true);
    VisItSetParallelRank(BASIN_ID);

    VisItSetupEnvironment();
    addConnection ( "Shelly_Button_3", "clicked()", &testSlot);
    addConnection ( "Shelly_Button_3", "clicked()", &testSlot2);
    addConnection ( "Top_Button_1", "clicked()", &testSlot2);
    addConnection ( "Bottom_Button_2", "clicked()", &testSlot);
    addConnection ( "RadioButton1", "clicked()", &testSlot2);
    addConnection ( "RadioButton2", "clicke()", &testSlot2);
    addConnection ( "RadioButton3", "clicked()", &testSlot2);
    // monitor value changed if you care about a change
    // when some other radio button is pressed.
    addConnection ( "RadioButton1", "stateChanged()", &testSlot2);
    addConnection ( "RadioButton2", "stateChanged()", &testSlot2);
    addConnection ( "RadioButton3", "stateChanged()", &testSlot2);
    
    addConnection ( "ShellyLineEdit1","textChanged()", &valueChanged);
    addConnection ( "ShellyTable_1","currentChanged()", &currentChanged);
    addConnection ( "ShellySlider_1","valueChanged()", &valueChanged);
    addConnection ( "ShellyDial_1","valueChanged()", &valueChanged);
    addConnection ( "apply", "clicked()", &apply);

    addConnection ( "timeEdit1" ,"valueChanged()", &valueChanged);
    addConnection ( "dateEdit1" ,"valueChanged()", &valueChanged);
    addConnection ( " CheckBox1", "clicked()" , &testSlot2);
}

#define VISIT_COMMAND_PROCESS 0
#define VISIT_COMMAND_SUCCESS 1
#define VISIT_COMMAND_FAILURE 2

static void BroadcastSlaveCommand(int *command){
  MPI_Bcast(command, 1, MPI_INT, 0, MPI_COMM_WORLD);
}

void SlaveProcessCallback(){
  int command = VISIT_COMMAND_PROCESS;
  BroadcastSlaveCommand(&command);
}

int ProcessVisItCommand(){
    int command;
    //if(BASIN_ID==0) cerr << "Processing command from visit. ";
    if(BASIN_ID==0){
      int success = VisItProcessEngineCommand();
      if(success){
	command = VISIT_COMMAND_SUCCESS;
	BroadcastSlaveCommand(&command);
	return 1;
      }else{
	command = VISIT_COMMAND_FAILURE;
	BroadcastSlaveCommand(&command);
	return 0;
      }
    } else {
      while(1){
	int command;
	BroadcastSlaveCommand(&command);
	switch(command){
  	  case VISIT_COMMAND_PROCESS:
	    VisItProcessEngineCommand();
	    break;
	  case VISIT_COMMAND_SUCCESS:
	    return 1;
	  case VISIT_COMMAND_FAILURE:
	    return 0;
	}
      }
    }
}

void StopSimulation(){
    VisItTimeStepChanged();
  //    cerr<<"Not Made\n\n";
    if(BASIN_ID==0){
      cerr << "Known commands:\n";
      cerr << "\t2root  :\tsquare roots newest variable\n";
      cerr << "\tsquare :\tsquares newest variable\n";
      cerr << "\tcheck  :\tStops a run\n";
      cerr << "\tadd    :\tAdd new data points to all variables\n";
      cerr << "\tquit   :\texit code\n";
    }
}
